it-swarm.com.ru

Глоток не может справиться со стрелками

Я пытаюсь сжать свой проект с помощью gulp-uglify, однако gulp, похоже, выдает ошибку Unexpected token: punc () всякий раз, когда в коде встречается функция стрелки. Что я могу сделать, чтобы это исправить? Спасибо.

проглатывать-краш-test.js

// Function with callback to simulate the real code
function test(callback) {
    if (typeof callback === "function") callback();
}

// Causes a crash
test(() => {
    console.log("Test ran successfully!");
});

// Doesn't cause a crash
test(function () {
    console.log("Test ran successfully!");
});

gulpfile.js

var gulp = require("gulp");
var concat = require("gulp-concat");
var uglify = require("gulp-uglify");

gulp.task("scripts", function() {
    gulp.src([
        "./gulp-crash-test.js"
    ]).pipe(
        concat("gulp-crash-test.min.js")
    ).pipe(
        uglify().on('error', function(e){
            console.log(e);
        })
    ).pipe(
        gulp.dest("./")
    );
});

gulp.task("watch", function() {
    gulp.watch("./gulp-crash-test.js", ["scripts"]);
});

gulp.task("default", ["watch", "scripts"]);
21
Paradoxis

Функции стрелок являются функцией ES6. Babel (и другие) предназначены для перевода ES6 в ES5 или более раннюю версию в процессе сборки. К счастью, есть плагины Babel для Gulp и Grunt. Беги, Бабель, прежде чем углишь.

https://www.npmjs.com/package/gulp-babel

Я надеюсь, что это направит вас в правильном направлении/кто-то может продемонстрировать некоторый код.

22
James Garner

Для синтаксиса ES6 нет вспомогательных утилит (минимизировать). Вы должны выполнить задачу gulp после компиляции babel (es6 -> es5)

1. установить пакеты

npm install gulp-babel babel-preset-es2015

2. измените свой код, как показано ниже.

    var gulp = require("gulp");
    var concat = require("gulp-concat");
    var uglify = require("gulp-uglify");
    var babel  = require('gulp-babel');

    gulp.task("scripts", function() {
        return gulp.src(["./gulp-crash-test.js"])
    .pipe(babel({presets: ['es2015']}))
    .pipe(concat("gulp-crash-test.minjs"))
    .pipe(uglify().on('error', function(e){
         console.log(e);
    }))
    .pipe(gulp.dest("./"))
    });
23
superui

Вы можете использовать babel minify (ранее Babili) библиотеку на основе babel для минимизации кода ES6 без переноса:

Сначала установите через npm:

npm install --save-dev babel-preset-minify

Тогда в вашем файле gulp:

var gulp = require('gulp')
var babel = require('gulp-babel')
gulp.task('default', () => {
  return gulp.src('src/app.js')
  .pipe(babel({presets: ['minify']}))
  .pipe(gulp.dest('dist'))
})

Он использует babel в качестве парсера, но транспиляции нет.

11
Gabriel Furstenheim

Я попробовал babeli, это вроде отстой. Время сборки заняло у меня 40-е годы. И я не собираюсь переносить код в es5 в любом случае

Я предпочитаю использовать uglify-es, следуя описаниям https://www.npmjs.com/package/uglify-eshttps://www.npmjs.com/package/gulp- унизить

Мое время сборки сейчас 10 с. У меня есть терпение ждать 10 секунд.

Это мой глоток

var gulp = require('gulp');
var uglifycss = require('gulp-uglifycss');
var htmlminifier = require('gulp-html-minifier');
var useref = require('gulp-useref');
var gulpif = require('gulp-if');
var clean = require('gulp-clean');
var uglifyes = require('uglify-es');
var composer = require('gulp-uglify/composer');
var minifyes = composer(uglifyes, console);

.pipe(gulpif('*.js', minifyes()))
3
ColacX

Это то, что я использую для useref с angular и babel.

gulp.task('concat-js', ['your dependency task'],function(){
  return gulp.src('dev/dev_index/index.html')
    .pipe(useref())
    .pipe(gulpif('*.js', ngAnnotate())) // if you use angular
    .pipe(gulpif('*.js',babel({
        compact: false,
        presets: [['es2015', {modules: false}]]
     })))
    .pipe(gulpif('*.js', uglify({ compress: false })
    .pipe(gulp.dest('./'));
});
0
Harel Levy

первый 'babel' файл .js 

var babel = require('gulp-babel');
gulp.task('babel-js', () =>
gulp.src('js/main.js')
 .pipe(babel({presets: ['env']}))
 .pipe(gulp.dest('build/babel'))
);

https://www.npmjs.com/package/gulp-babel

чем "унизить" это

var uglify = require('gulp-uglify'), pump = require('pump');
gulp.task('uglify-js', function (cb) {
   pump([
     gulp.src('build/babel/main.js'),
     uglify(),
     gulp.dest('build/js')
   ],
   cb
);
});

https://www.npmjs.com/package/gulp-uglify

Быть установленным 

npm install --save-dev gulp-babel babel-core babel-preset-env
npm install uglify-es -g
npm install pump
0
Dan Alboteanu